<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

#
# fichier bas sur celui du plugin Gallery
#



require dirname(__FILE__).'/../../inc/prepend.php';

if (isset($auth)) $auth->check(9);
else auth::check(9);


# clear -> effacement des mots de passe : dsactivation du hash
# hash  -> hachage des mots de passe : activation du hash
$clear = !empty($_REQUEST['clear']) ? true : false;
$hash  = !empty($_REQUEST['hash'])  ? true : false;

# id de la ligne de la table passCat dans le cas du hash,
# sinon il s'agit du cat_id pour le cas de clear
$id = !empty($_REQUEST['id'])? $_REQUEST['id'] : NULL;

# le mot de passe (cas clear)
$pwd = !empty($_REQUEST['pwd'])? $_REQUEST['pwd'] : NULL;

# hash du mot de passe (cas hash)
$hashpwd = !empty($_REQUEST['hashpwd'])? $_REQUEST['hashpwd'] : NULL;

$plugin_name = 'passcat';

/* Rcupration des fichiers de langues */
if (defined('DC_LANG')) {
        if (dc_encoding == 'UTF-8') {
                l10n::set('l10n/'.DC_LANG.'-utf8/hash_passCat');
        }
        else {
                l10n::set('l10n/'.DC_LANG.'/hash_passCat');
        }
}


function update_passCat_table() {
	global $clear, $hash, $id, $pwd, $hashpwd;

	# on ouvre la connexion  la base
	$con = new connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);

	# si la connexin ne s'est pas faite
	if ($con->error()) {
        	$err.= '<item status="failure" text="MySQL Error : '.$con->error().'" />';
		close_con();
		exit;
	}
	# si la connexino est ok
	else {
		# on dfini la requete suivant que c'est "clear" ou "hash"
		if ($clear) {
        	        $req = 'UPDATE '.DB_PREFIX.'passcat '.
                	       'SET cat_passwd = \''.$pwd.'\' '.
                       		'WHERE cat_id = \''.$id.'\'';
		}
		elseif ($hash) {
			$req = 'UPDATE '.DB_PREFIX.'passcat '.
	               		'SET cat_passwd = \''.$hashpwd.'\' '.
	               		'WHERE passcat_id = \''.$id.'\'';
		}

		# Ensuite, on excute la requete
		# si a marche pas
        	if ( !$con->execute($req) ) {
			if ($clear) {
				echo '<item status="failure" text="'.
				  sprintf(__('Error while updating password for row %s.'),$id).
				  '" />'."\n";
			}
			elseif ($hash) {
				echo '<item status="failure" text="'.
			 	 sprintf(__('Error while converting password for row %s.'),$id).
			 	 '" />'."\n";
			}
		}
		# si a marche
		else {
			if ($clear) {
                        	echo '<item status="success" text="'.
				  sprintf(__('Update password for row %s : OK'),$id).'" />'."\n";
			}
			elseif ($hash) {
				echo '<item status="success" text="'.
			 	 sprintf(__('Convert password for row %s : OK'),$id).'" />'."\n";
			}
		}

		# finalement, on ferme la connexion  la base de donnes
		if (!empty($con) && is_object($con)) {
                	$con->close();
        	}
	}
}


# le document XML qui sera envoy
# Content-type: text/xml
# <items>
#  <item status="success" text="..." />
#  <item status="failure" text="..." />
# </items>

header('Content-Type: text/xml');
echo "<items>";
update_passCat_table();
echo "</items>";

?>
