<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

#
# ce fichier a t construit sur la base du fichier "thumbnail.php"
# du plugin Gallery 
#

# Fichier "standalone", tests d'authentification au cas o 
require dirname(__FILE__).'/../../inc/prepend.php';

if (!empty($_GET['logout'])) $_SESSION = array();

if (isset($auth)) $auth->check(9);
else auth::check(9);

# pour lancer le processus : redfinition ou hache des mots de passe
$process = (!empty($_POST['process']) && $_POST['process'] == 'true') ? true : false;

# pour r-entrer tous les mots de passes
$clear = (!empty($_GET['clear']) && $_GET['clear'] == '1') ? true : false;

# pour hacher les mots de passe
$hash = (!empty($_GET['hash']) && $_GET['hash'] == '1') ? true : false;


# Rcupration des fichiers de langues
if (defined('DC_LANG')) {
	if (dc_encoding == 'UTF-8') {
		l10n::set('l10n/'.DC_LANG.'-utf8/hash_passCat');
	}
	else {
		l10n::set('l10n/'.DC_LANG.'/hash_passCat');
	}
}

#dfinition du titre de la page
if($clear)    $page_title = __('Define passCat passwords again');
elseif($hash) $page_title = __('Hash passCat passwords');
else	      $page_title = '';


commonHeaders('');

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" '.
     ' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n".
     '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.DC_LANG.'" lang="'.DC_LANG.'">'."\n".
     ' <head>'."\n".
     '  <title>'.$page_title.' - DotClear</title>'."\n".
     '  <link rel="stylesheet" type="text/css" href="../../style/default.css" />'."\n".
     '  <script type="text/javascript" src="../../js/tools.js"> </script>'."\n";


if ($clear) {

	# ce tableau va contenir l'id comme cl et le mot de passe en valeur
	$passwd_cat = array();
	foreach($_POST as $key => $val) {
		$result = array();
		# on recherche "pwd_cat_1, pwd_cat_7, etc dans la var $_POST
		# cela provient du formulaire
		if(preg_match("/^pwd_cat_(\d+)$/",$key,$result)) {
			$passwd_cat[$result[1]] = $val;
		}
	}

	$warn = false;
	$empty_cat = '';
	$actions = array();
	if (!empty($passwd_cat)) {
		foreach($passwd_cat as $key => $val) {
			if ($val == '') {
				# s'il n'y pas de mot de passe warn=true et on sort
				# pour par la suite pouvoir afficher un message disant
				# qu'un des champs (celui dfini  l'aide de $empty_cat)
				# est vide
				$warn = true;
				$empty_cat = $key;
				break;
			}
			else {
				# sinon on ajoute une action
				$actions[] = '"actions.php?id='.$key.'&pwd='.$val.'&clear=1"';
			}
		}
	}
	
	# si le processus doit tre lanc et qu'il n'y a pas de warning
	if ( $process && !$warn ) {

		# on lance les actions

		$actionTxt = 'var actions = new Array('.implode(",\n",$actions).');';
	
		echo '  <script type="text/javascript" src="inc/js/xmlhttprequest.js"> </script>'."\n".
		     '  <script type="text/javascript" src="inc/js/passCat_hashPasswords.js"> </script>'."\n";

		echo '  <script type="text/javascript">'."\n".
		     '	  '.$actionTxt."\n"."\n".
		     '    var l10n = new Array();'."\n".
		     '    l10n["Canceled"] = "'.__('Canceled').'";'."\n".
		     '    l10n["Close"] = "'.__('Close').'";'."\n".
		     '  </script>';

		echo ' </head>'."\n".
		     ' <body class="popup" onload="doProcess();">'."\n".
		     '  <div id="main">'."\n".
		     '   <div id="content">'."\n";

		echo '    <h2>'.$page_title.'</h2>'."\n";
		echo '    <p>'.__('Please wait, updating passCat passwords...').'</p>'."\n";
		echo '    <div id="progress" '.
		     '         style="width: 80%;border: 1px solid black; background: #fff; padding:0;">'."\n";
		echo '     <div id="progressbar" '.
		     '          style="width: 5%; background: #0f0; border-right: 1px solid black; text-align: center;">'."\n";
		echo '0%'."\n";
		echo '     </div>'."\n";
		echo '    </div>'."\n";
		echo '    <p><input type="button" id="cancel" name="cancel" onclick="doCancel();" value="'.__('Cancel').'"/></p>'."\n";
		echo '    <div id="process"></div>'."\n";
		echo '   </div>'."\n".
		     '  </div>'."\n".
		     '  <p class="small center">'."\n".
		     '   <a href="#" onclick="window.close();">'."\n".
		__('Close this window')."\n".
		     '   </a>'."\n".
		     '  </p>'."\n".
		     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
		     ' </body>'."\n".
		     '</html>';	
	}
	# sinon on affiche le formulaire pour remplir les mots de passe, avec les warning au niveau des
	# des champs prcdemment vide si besoin
	else {
		$err = '';

		$con = new connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);

		if($con->error()) {
			$err.= '<p>MySQL Error : '.$con->error().'</p>';
		}

		$req = 'SELECT passcat_id, cat_libelle, C.cat_id '.
		       'FROM '.DB_PREFIX.'passcat P, '.DB_PREFIX.'categorie C '.
		       'WHERE P.cat_id = C.cat_id';

		if ( ($rs = $con->select($req)) == false ) {
			$err.= '<p>MySQL Error : '.$con->error().'</p>';
		}

		#message s'il y a eu une erreur au niveau de la base de donnes
		if ($err != ''){

			echo " </head>\n".
			     ' <body class="popup" >'."\n".
			     '  <div id="main">'."\n".
			     '   <div id="content">'."\n";

			echo '    <h2>'.$page_title.'</h2>';
			echo '    '.$err;

			echo '   </div>'.
			     '  </div>'.
			     '  <p class="small center"><a href="#" onclick="window.close();">'.
			     __('Close this window').'</a></p>'.
			     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
			     ' </body>'.
			     '</html>';
		}
		# sinon, on affiche bien le formulaire et le warning si besoin
		else {
			echo ' </head>'."\n".
			     ' <body class="popup" >'."\n".
			     '  <div id="main">'."\n".
			     '   <div id="content">'."\n";
	
			echo '    <h2>'.$page_title.'</h2>'."\n";
			
			if ($warn) echo '     <p style="color:red">'.__('Please, fill red field').'</p>'."\n";
			
			echo '    <form action="hashPasswords.php?clear=1" method="post">'."\n";
	
			while ($rs->fetch()) {
				$passcat_id  = $rs->f('passcat_id');
				$cat_libelle = $rs->f('cat_libelle');
				$cat_id      = $rs->f('cat_id');
				
				$style = '';
				
				if ($warn && ($cat_id == $empty_cat)) $style = ' style="background-color:red;" ';
	
				echo '   <p'.$style.'>'."\n";
				echo '     <label for="cat_'.$cat_id.'"><strong>'.$cat_libelle.'&nbsp;: </strong></label>'."\n".
				     '     <input size="40" name="pwd_cat_'.$cat_id.'" id="cat_'.$cat_id.'"'.
				     '            maxlength="255" value="'.
				    ((empty($passwd_cat) && array_key_exists($cat_id,$passwd_cat)) ? '' : $passwd_cat[$cat_id] ).
				     '" class="max" type="text" />';
				echo '   </p>'."\n";
			}

			echo '     <p><input name="process" value="true" type="hidden" /></p>'."\n".
			     '     <p><input class="submit" name="submit" value="'.__('Update').'" type="submit" /></p>'."\n";
			echo '    <p>'.dcNonce::form().'</p>'."\n";
			echo '    </form>'."\n";
			echo '   </div>'."\n".
			     '  </div>'."\n".
			     '  <p class="small center">'."\n".
			     '   <a href="#" onclick="window.close();">'."\n".
			     __('Close this window')."\n".
			     '   </a>'."\n".
			     '  </p>'."\n".
			     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
			     ' </body>'."\n".
			     '</html>';
		}

		# enfin on ferme la connexion
		if (!empty($con) && is_object($con)) {
			$con->close();
		}
	}
}
elseif ($hash) {

	if ($process) {

		$err = '';

		$con = new connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);

		if($con->error()) {
			$err.= '<p>MySQL Error : '.$con->error().'</p>';
		}

		$req = 'SELECT passcat_id,cat_passwd FROM '.DB_PREFIX.'passcat';

		if ( ($rs = $con->select($req)) == false ) {
			$err.= '<p>MySQL Error : '.$con->error().'</p>';
		}

		if ($err != ''){

			echo " </head>\n".
			     ' <body class="popup" >'."\n".
			     '  <div id="main">'."\n".
			     '   <div id="content">'."\n";
	
			echo '    <h2>'.$page_title.'</h2>';
			echo '    '.$err;
	
			echo '   </div>'.
			     '  </div>'.
			     '  <p class="small center"><a href="#" onclick="window.close();">'.
			     __('Close this window').'</a></p>'.
			     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
			     ' </body>'.
			     '</html>';
		}
		else {
			$actions = array();
	
			while ($rs->fetch()) {
				# on hash tout de suite le mot de passe comme a il ne passera pas en clair dans l'url
				$hash = md5($rs->f('cat_passwd'));
				$id = $rs->f('passcat_id');
				$actions[] = '"actions.php?id='.$id.'&hashpwd='.$hash.'&hash=1"';
			}
	
			$actionTxt = 'var actions = new Array('.implode(",\n",$actions).');';
	
			echo '  <script type="text/javascript" src="inc/js/xmlhttprequest.js"> </script>'."\n".
			     '  <script type="text/javascript" src="inc/js/passCat_hashPasswords.js"> </script>'."\n";
	
			echo '  <script type="text/javascript">'."\n".
			     '	  '.$actionTxt."\n"."\n".
			     '    var l10n = new Array();'."\n".
			     '    l10n["Canceled"] = "'.__('Canceled').'";'."\n".
			     '    l10n["Close"] = "'.__('Close').'";'."\n".
			     '  </script>';
	
			echo ' </head>'."\n".
			     ' <body class="popup" onload="doProcess();">'."\n".
			     '  <div id="main">'."\n".
			     '   <div id="content">'."\n";
	
			echo '    <h2>'.$page_title.'</h2>'."\n";
			echo '    <p>'.__('Please wait, converting passCat passwords...').'</p>'."\n";
			echo '    <div id="progress" '.
				      'style="width: 80%;border: 1px solid black; background: #fff; padding:0;">'."\n";
			echo '     <div id="progressbar" '.
				       'style="width: 5%; background: #0f0; border-right: 1px solid black; text-align: center;">'."\n";
			echo '0%'."\n";
			echo '     </div>'."\n";
			echo '    </div>'."\n";
			echo '    <p><input type="button" id="cancel" name="cancel" onclick="doCancel();" value="'.__('Cancel').'" /></p>'."\n";
			echo '    <div id="process"></div>'."\n";
			echo '   </div>'."\n".
			     '  </div>'."\n".
			     '  <p class="small center">'."\n".
			     '   <a href="#" onclick="window.close();">'."\n".
				__('Close this window')."\n".
			     '   </a>'."\n".
			     '  </p>'."\n".
			     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
			     ' </body>'."\n".
			     '</html>';
	
		}

		if (!empty($con) && is_object($con)) {
			$con->close();
		}
	}
	# pas process, donc on afffiche une page de prvention :D
	else {
		echo " </head>\n".
		     ' <body class="popup" >'."\n".
		     '  <div id="main">'."\n".
		     '   <div id="content">'."\n";

		echo '    <h2>'.$page_title.'</h2>';
		echo '     <p style="text-align: center; color: red;">'.
		     '      <b>'.__('Don\'t convert an already converted passCat table !!!').'</b>'.
		     '     </p>';

			echo '    <form action="hashPasswords.php?hash=1" method="post">'."\n".
			     '      <p><input name="process" value="true" type="hidden" /></p>'."\n".
			     '      <p><input class="submit" name="submit" value="'.__('Convert').'" type="submit" /></p>'."\n".
			     '      <p>'.dcNonce::form().'</p>'."\n".
			     '    </form>'."\n";
	
			echo '   </div>'.
			     '  </div>'.
			     '  <p class="small center"><a href="#" onclick="window.close();">'.
			     __('Close this window').'</a></p>'.
			     '  <div id="footer"><img src="../../images/dotclear_pw.png" alt="dotclear blog" /></div>'."\n".
			     ' </body>'.
			     '</html>';

	}
}

# Fermeture de la connexion
if (isset($_SESSION)) {
	session_write_close();
}

?>
