<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


passCat_info('==> inc/classes/class.passcat.php');

class passCat {
	var $auth;
	var $error;
	var $warning;
	var $share;

	# pour l'authentification HTTP pour les flux...
	var $HTTP_auth; //indique si on est en authentification HTTP
	var $HTTP_auth_OK;  //indique si a s'est bien pass :)

	function passCat() {
		$this->auth = false;
		$this->error = '';
		$this->share = DC_SHARE_DIR.'/passCat';
		$this->HTTP_auth = false;
		$this->HTTP_auth_OK = false;

		if (!file_exists($this->share)) files::makeDir($this->share);

		passCat_info('passCat::passCat()');
		passCat_info('  auth  = '.$this->auth);
		passCat_info('  erro  = '.$this->error);
		passCat_info('  share = '.$this->share);
		passCat_info('  HTTP_auth_OK = '.$this->HTTP_auth_OK);
	}

	function getAuth() {
		passCat_info('passCat::getAuth()='.$this->auth);
		return $this->auth;
	}

	function setAuth($value = false) {
		$this->auth = $value;
		passCat_info('passCat::setAuth('.$value.')');
		#cache  jour pour index.
		#files::touch(dc_app_url.'index.php');
	}

	function getHTTPAuth() {
		return $this->HTTP_auth;
	}

	function setHTTPAuth($value = false) {
		$this->HTTP_auth = $value;
		passCat_info('passCat::setHTTPAuth('.$value.')');
	}


	function getHTTPAuthOK() {
		return $this->HTTP_auth_OK;
	}

	function setHTTPAuthOK($value = false) {
		$this->HTTP_auth_OK = $value;
		passCat_info('passCat::setHTTPAuthOK('.$value.')');
	}

	function getError() {
		return $this->error;
	}

	function setError($err='') {
		$this->error = $err;
	}

	function authentication() {
		global $blog, $cat_id, $post_id;

		passCat_info('passCat::authentication()');
		passCat_info('  + cat_id  = '.$cat_id);
		passCat_info('  + post_id = '.$post_id);

		if ( $post_id != '' ) {
			$req = 'SELECT cat_id FROM '.$blog->t_post.' '.
				'WHERE post_id = \''.$post_id.'\'';

			if ( ($rs = $blog->con->select($req)) == false ) {
				$this->error = 'authentication : Pb avec le post_id... :(';
				trigger_error('  ! MySQL : '.$blog->con->error(), E_USER_ERROR);
			}
			else {
				$cat_id = $rs->f(0);
			}
		}

		# un mot de passe est-il fourni ?
		if( !empty($_POST['cat_passwd']) ) {

			# il est en clair...
			$passwd = $_POST['cat_passwd'];
			
			passCat_info('  + mot de passe fourni : '.$passwd);

			# suivant configuration, il est soit en clair, soit hach 
			if (PASSCAT_HASH) {
				# si hach, faut faire de mme avec le pass fournit
				$passwd = md5($passwd);
			}
			# on rcupre le mot de passe de la table passCat, hach ou non
			$cat_passwd = $blog->getPassCat($cat_id);

			passCat_info('  + mot de passe de la base : '.$cat_passwd);

			# on verifie que c'est le bon mot de passe
			if( $cat_passwd == $passwd ){
				# on rcupre les donnes du cookie s'il existe dj
				if (!empty($_COOKIE['passcat'])) {
					$data = unserialize($_COOKIE['passcat']);

					passCat_info('  + Le cookie passcat existe :');

					foreach($data as $key => $val) {
						trigger_error('     - data['.$key.'] = '.$val);
					}
				}

				# creation du cookie passcat[cat_id]
				$expire = 24*3600; # dure de 24h
				# on le met en md5 ds le cookie
				$data[$cat_id]=md5($cat_passwd);

				passCat_info('  + Ajout de data['.$cat_id.'] = '.$data[$cat_id]);

				if (setcookie("passcat",serialize($data),time()+$expire,"/")) {
					passCat_info('  + Nouveau cookie passcat enregistr');
				}
				else {
					trigger_error('  ! Cookie passcat non enregistr', E_USER_ERROR);
				}

				return true;
			}
			else {
				passCat_info('  + Les deux mots de passe ne correspondent pas');
				passCat_info('      `-> d\'o $this->auth = true et return false');
				$this->warning = __('Login failed. Please try again.');
				$this->auth = true;
				return false;
			}
		}
		else {
			passCat_info('  + Mot de passe non fournit');
			passCat_info('      `-> d\'o $this->auth = true et return false');

			$this->warning = __('Please enter a password.');
			$this->auth = true;
			return false;
		}

	}

	function formAuth() {

		global $blog, $cat_id, $post_id, $dc_template_file;

		passCat_info('passCat::formAuth()');
		passCat_info('  + cat_id  = '.$cat_id);
		passCat_info('  + post_id = '.$post_id);

		$form = '';
		$cat_libelle = '';
		$cat_libelle_url = '';

		if ( ($cat_id == '' && $post_id == '') || !$this->auth) { 
			passCat_info('  `-> return false;');
			return false;
		}

		# si on est dj pass par le formulaire d'authentification
		# on vrifie l'authentification
		
		# s'il s'agit d'un post, on doit rcuprer sa catgorie
		if ($post_id != '') {
			$req = 'SELECT cat_id, post_titre_url, '.
			       'DATE_FORMAT(post_dt,\'%Y%m%d\') AS postdate, '.
			       'DATE_FORMAT(post_dt,\'%H:%i\') AS posthour, '.
			       'DATE_FORMAT(post_dt,\'%d\') AS postday, '.
			       'DATE_FORMAT(post_dt,\'%m\') AS postmonth, '.
			       'DATE_FORMAT(post_dt,\'%Y\') AS postyear '.
			       'FROM '.$blog->t_post.' '.
			       'WHERE post_id = \''.$post_id.'\'';

			if( ($post = $blog->con->select($req)) == false ) {
				$this->error = 'Pb avec le post_id... :(';
				trigger_error('  ! MySQL : '.$blog->con->error(), E_USER_ERROR);
			}
			else {
				$cat_id = $post->f('cat_id');
				$post_titre_url = $post->f('post_titre_url');
				$postday = $post->f('postday');
				$postmonth = $post->f('postmonth');
				$postyear = $post->f('postyear');
				$post_url = $postyear.'/'.$postmonth.'/'.$postday.'/'.$post_id.'-'.$post_titre_url;
			}
		}			

		$cat_id = $blog->getNumCatId($cat_id);

		# la catgorie existe-t'elle et est-elle protge ?
		if( $blog->checkCat($cat_id) ) {
			if ( $blog->checkPassCat($cat_id) ) {
				# on rcupre le libell de la catgorie pour pouvoir l'afficher :D
				$req = 'SELECT cat_libelle, cat_libelle_url FROM '.$blog->t_categorie.' '.
					'WHERE cat_id = \''.$cat_id.'\'';

				if( ($rs = $blog->con->select($req)) != false ){
					$cat_libelle = $rs->f(0);
					$cat_libelle_url = $rs->f(1);
				}
				else {
					$this->error = 'Pas de libelle pour cette catgorie :(';
					trigger_error('  ! MySQL : '.$blog->con->error(), E_USER_ERROR);
				}
			}
			else {
				$this->error = 'La catgorie n\'est pas protge';
				passCat_info('  + La catgorie n\'est pas protge');
			}
			
		}
		else {
			$this->error = 'La catgorie n\'existe pas';
			passCat_info('  + La catgorie n\'existe pas');
		}


		if (!empty($this->error)) {
			$form.= '  <p style="text-align:center;"><strong>'.$this->error.'</strong></p>';
		}
		else {
			if(!empty($this->warning)) {
				$form.= '  <p style="text-align:center;"><strong>'.$this->warning.'</strong></p>';
			}

			passCat_info('  + Affichage du formulaire');

			# on va crer l'url d'action de faon  rediriger vers le contenu
			# d'une catgorie, ou un post suivant son ID ou sa date
			if ($post_id != '') {
				$query = 'p='.$post_id;
			}
			else {
				$query = 'cat='.$cat_id;
			}

			# les diffrents lments qui seront intgrs au formulaire
			# que ce soit celui externe ou celui par dfaut (qui suit)
			$form_elements = array(
				'PASSCAT_BEGIN_FORM' => '<form action="'.dc_app_url.'/index.php?'.$query.'"; method="post">',
				'PASSCAT_PASSWORD'   => '<input name="cat_passwd" id="cat_passwd" type="password" tabindex="2" />',
				'PASSCAT_END_FORM'   => '<input type="hidden" name="auth" value="true" >'.
				                        '<input type="hidden" name="cat_libelle_url" value="'.$cat_libelle_url.'" >'.
					                      (($post_id != '') ? '<input type="hidden" name="post_url" value="'.$post_url.'" >' : '').
				                        '</form>',
				'PASSCAT_CAT'	       => $cat_libelle
			);

			if (PASSCAT_EXT_FORM_AUTH) {
				passCat_info('  + PASSCAT_EXT_FORM_AUTH = true');
				# on ouvre le fichier qui doit tre plac dans le rpertoire du thme actuel
				# on le lit et remplit la variable $form avec
				$auth_path = $this->share.'/passCat_auth';
				if (file_exists($auth_path)) {
					$auth_content = file_get_contents($auth_path);
					passCat_info('  + contenu du fichier externe : '."\n".$auth_content);
					foreach($form_elements as $origine => $replace) {
						$auth_content = preg_replace('#\$'.$origine.'#', $replace, $auth_content);
					}
					passCat_info('  + contenu du fichier externe aprs remplacement : '."\n".$auth_content);
					$form .= $auth_content;
				}
				else {
					$form .= '<strong>File : '.$auth_path.' does not exist !</strong>';
				}
	
			}
			else {
				$form.= '<div style="text-align:center;" >';	
				$form.=	   $form_elements['PASSCAT_BEGIN_FORM'];
				$form.=	'    <div class="login">';
				$form.= '      <p><strong>'.__('Category').': '.$form_elements['PASSCAT_CAT'].'</strong></p>';
				$form.= '      <p>';
				$form.= '        <label for="cat_passwd"><strong>'.__('Password').' :</strong></label> ';
				$form.=          $form_elements['PASSCAT_PASSWORD'];
				$form.= '      </p>';
				$form.= '      <p><input class="submit" type="submit" value="'.__('ok').'" /></p>';
				$form.= '      <p>'.__('You must accept cookies in order to use the private area.').'</p>';
				$form.= '    </div>';
				$form.=    $form_elements['PASSCAT_END_FORM'];
				$form.= '</div>';
			}
		
			if (empty($this->error)) {
				$form.= '<script type="text/javascript">';
				$form.= '  document.getElementById(\'cat_passwd\').focus();';
				$form.= '</script>';
			}
		}

		return $form;
	}

	/**
	@function passCatLogout

	Cette fonction affiche un lien permettant de dtruire le
	cookie "passcat". Elle ne renvoie rien si le cookie
	n'existe pas :)
	*/
	function passCatLogout() {

		passCat_info('passCat::passCatLogout()');

		if (isset($_COOKIE['passcat'])) {
			passCat_info('  + Affichage du lien');
			echo '<a href="'.dc_app_url.'/index.php?passCatDelCookie=1">[<i>'.
				__('logout').'</i>]</a>';
		}
	}

	function delCookie(){
		global $blog;

		passCat_info('passCat::delCookie()');

		if (setcookie("passcat","",time()-3600,"/")) {
			unset($_COOKIE['passcat']);
			passCat_info('  + Cookie passcat effac');
			return true;
		}
		else {
			trigger_error('  ! Cookie passcat non-effac', E_USER_ERROR);
			return false;
		}
	}

}

passCat_info('<== inc/classes/class.passcat.php');

?>
