<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


passCat_info('==> inc/functions_admin.php');

# les fonctions d'affichage de l'interface admin

# Formulaire de cration de la table
function passCat_form_tb_creation(){
	global $url;

	buffer::str('<h3>'.__('passCat Table Creation').'</h3>');
	buffer::str('<p>'.__('This operation will create the passcat table where the passwords '.
	        'of the protected categories will be stored').'</p>'.
	        '<form method="post" action="'.$url.'">'.
	        '<p>'.
	        '<input type="hidden" name="createtb" value="1"/>'.
	        '<input type="submit" class="submit" value="'.__('Create Table').'"/>'.
	        dcNonce::form().
	        '</p>'.
	        '</form>'
	);
}

# Cration de la table
function passCat_tb_creation(){
	global $con;

	$sql = 'CREATE TABLE '.DB_PREFIX.'passcat ('.
	       'passcat_id int(11) NOT NULL auto_increment,'.
	       'cat_id int(11) NOT NULL,'.
	       'cat_passwd varchar(32) binary NOT NULL default \'\','.
	       'PRIMARY KEY  (passcat_id)'.
	       ')';

	if ( ($rs = $con->execute($sql)) == false ) {
		buffer::str('Impossible to create table');
		buffer::str($con->error());
	}

	passCat_list_cat();
}


# formulaire d'ajout d'un mot de passe  une catgorie
function passCat_form_passwd(){
	global $PLUGIN_HEAD, $url, $cat_id, $con, $passwd;


	#$PLUGIN_HEAD .= '  <script language="Javascript">'."\n".
	$PLUGIN_HEAD .= '  <script type="text/javascript">'."\n".
	                '    var elements = { "checkcat_pass" : "p_passwd" };'."\n".
	                '  </script>'."\n".
	                '  <script src="tools/passcat/inc/js/passCat_hideOrNot.js" type="text/javascript"></script>'."\n";

	$noCheck = (!empty($_POST['noCheck'])) ? $_POST['noCheck'] : '';

	$error = false;

	# s'il s'agit de la premire fois
	if ($noCheck == '') {
	
		# rcupre les infos de la table passcat concernant la catgorie
		$sql = 'SELECT cat_id, cat_passwd FROM '.DB_PREFIX.'passcat '.
		       'WHERE cat_id = \''.$cat_id.'\'';

		if ( ($rs = $con->select($sql)) == false ) {
			$error = true;
			buffer::str($con->error());
		}
		else {
			# si cette catgorie n'est pas dans la table
			if ($rs->isEmpty()) {
				#le mot de passe est vide et la case non coche
				$passwd = '';
				$checked= '';
			}
			else {
				# sinon on rcupre le mot de passe est on coche la case
				$passwd = $rs->field('cat_passwd');
				$checked = 'true';
			}
		}
	}
	# sinon, s'il s'agit d'un retour (car le mot de passe tait vide par exemple)
	# la case doit tre coche
	else {
		$checked = 'true';
	}

	# s'il n'y a pas eu d'erreur dans la recherche ds la table
	if(!$error) {
		buffer::str('<form action="'.$url.'" method="post">');
		buffer::str('  <p>'.
		            form::checkbox('checkcat_pass','true',$checked,'','checkcat_pass').
		            __('Check to protect your category with a password').' '.
		            helpLink('passcat&amp;plugin=passcat','checkcat_pass').
		            '  </p>');
		buffer::str('  <p id="p_passwd">');

		# si les mots de passe sont hachs, on affiche une petite phrase avec ce dernier
		if (PASSCAT_HASH) buffer::str('     <i>'.__('Hashed password').' : '.$passwd.'</i><br /><br />');

		buffer::str('    <label><strong>'.__('Password').'&nbsp;: </strong> '.
		            helpLink('passcat&amp;plugin=passcat','password').
		            '    </label>'.
		# de plus si hachs, on ne l'affiche pas dans le champ
		form::field('passwd',40,255,( (PASSCAT_HASH) ? '' : $passwd ),'','class="max"').
		            '  </p>');

		buffer::str('  <p><br />'.
		            '    <input class="submit" type="submit" name="submit" value="'.
		            __('save').'" />'.
		           ((!empty($cat_id)) ? form::hidden('cat_id',$cat_id) : '').
		           '  </p>');
		# si on doit revenir  ce formulaire  cause du mot de passe non rempli
		# pas besoin de lancer la requte sql du dbut !
		buffer::str('<p>'.form::hidden('noCheck','true').'</p>');
		buffer::str('<p>'.form::hidden('updPasswd','true').'</p>');
		buffer::str('<p>'.dcNonce::form().'</p>');
		buffer::str('</form>');
	}
}

# Enregistrement du mot de passe d'une catgorie
function passCat_passwd(){
	global $cat_id, $passwd, $blog;

	$passwd = (!empty($_POST['passwd'])) ? $_POST['passwd'] : '';
	$checkcat_pass = (!empty($_POST['checkcat_pass'])) ? $_POST['checkcat_pass'] : '';

	if ($checkcat_pass != '') {
		if ($passwd != '') {
			# si les mots de passes sont hach, il faut ici les hacher...
			if (PASSCAT_HASH) $passwd = md5($passwd);
			$blog->updPassCat($cat_id,$passwd);
			passCat_list_cat();
		}
		else {
			# redirection pour remplir le mot de passe
			buffer::str('<strong>'.__('Please, fill the password field').'</strong>');
			passCat_form_passwd();
		}
	}
	else {
		$blog->delPassCat($cat_id);
		passCat_list_cat();
	}
}

# Affichage du contenu de la table passCat
function passCat_passCat_info(){
	global $url, $blog, $con;

	buffer::str('<h3>'.__('passCat Table').'</h3>');

	# requte principale : le contenu de la pable passCat associ  celui
	# de la table catgorie 
	$sql = 'SELECT P.cat_id, C.cat_libelle, C.cat_libelle_url, P.cat_passwd '.
	       'FROM '.$blog->t_passCategorie.' P '.
	       'LEFT JOIN '.$blog->t_categorie.' C '.
	       'ON P.cat_id=C.cat_id';

	if ( ($rs = $con->select($sql)) == false ) {
		buffer::str('MySQL : '.$con->error());
		return;
	}
	else {
		# le nombre d'entre dans la table
		$nb = $rs->nbRow();
		# le nombre d'entre sans correspondance dans la table categorie
		$orphelins = 0;
		while ( $rs->fetch() ) {
			if ( !$rs->f('cat_libelle') ) $orphelins++;
		}
		
		$txt_orphelins = '';
		if ($orphelins) {
			$txt_orphelins = '<span style="color: red;">'.
			                 sprintf(__('with %s orphan(s)'),$orphelins).'</span>';
		}

		buffer::str('<p>'.sprintf(__('passCat table has %s entries'),$nb).' '.$txt_orphelins.'</p>');

		if ($orphelins) {
			buffer::str('<p> ==&gt; '.__('You should clean your table...').
			            ' <a href="'.$url.'&info=1&clean=1">'.__('Click here').'</a>.</p>');
		}
	}

	# on affiche les donnes sous forme d'un tableau
	buffer::str('<table class="clean-table">');
	buffer::str('<tr><th>'.__('cat id').'</th>'.
	            '<th>'.__('category').'</th>'.
	            '<th>'.__('password').'</th></tr>');

	while ( $rs->fetch() ) {

		$row_orpheline='';
		if ( !$rs->f('cat_libelle') ) $row_orpheline=' style="background-color: red;" ';

		# on affiche la ligne du tableau
		buffer::str('<tr'.$row_orpheline.'><td>'.$rs->f('cat_id').'</td>'.
		            '<td>'.$rs->f('cat_libelle').'</td>'.
		            '<td>'.$rs->f('cat_passwd').'</td></tr>');
	}

	buffer::str('</table>');

}

# pour nettoyer la table passCat
function passCat_clean_table() {
	global $blog, $con;

	# requte principale pour effacer les lignes de la table passCat orphelines 
	$sql = 'SELECT P.passcat_id '.
	       'FROM '.$blog->t_passCategorie.' P '.
	       'LEFT JOIN '.$blog->t_categorie.' C '.
	       'ON P.cat_id=C.cat_id '.
	       'WHERE C.cat_id is NULL';

	if ( ($rs=$con->select($sql)) == false ) {
		return false;
	}
	else {
		while( $rs->fetch() ) {
			if ( !$con->execute('DELETE FROM '.$blog->t_passCategorie.
			                    ' WHERE passcat_id='.$rs->f('passcat_id')) ) {
				return false;
			}
		}

		# on va un peu optimizer la table tout de mme :D
		$sql = 'OPTIMIZE TABLE '.$blog->t_passCategorie;
		return $con->execute($sql);
	}

}

# Affichage du formulaire de configuration de passCat
function passCat_form_config() {
	global $PLUGIN_HEAD, $url;

	#$PLUGIN_HEAD .= '  <script language="Javascript">'."\n".
	$PLUGIN_HEAD .= '  <script type="text/javascript">'."\n".
	                '    var elements = { "passcat_debug"         : "p_passcat_logfile",'."\n".
	                '                     "passcat_hash"          : "p_passcat_hash",'."\n".
	                '                     "passcat_ext_form_auth" : "p_passcat_ext_file_auth", '."\n".
	                '                     "passcat_debug_turn"    : "p_passcat_debug_turn" };'."\n".
	                '  </script>'."\n".
	                '  <script src="tools/passcat/inc/js/passCat_hideOrNot.js" type="text/javascript"></script>'."\n";


	$debug            = (defined('PASSCAT_DEBUG'))         ? PASSCAT_DEBUG         : '';
	$debug_turn       = (defined('PASSCAT_DEBUG_TURN'))    ? PASSCAT_DEBUG_TURN    : '';
	# taille max de 1024 ko (1Mo) par dfaut
	$debug_max        = (defined('PASSCAT_DEBUG_MAX')&& PASSCAT_DEBUG_MAX != '') ? PASSCAT_DEBUG_MAX : '1024';
	#7 fichiers par dfaut
	$debug_nb         = (defined('PASSCAT_DEBUG_NB') && PASSCAT_DEBUG_NB != '')  ? PASSCAT_DEBUG_NB  : '7';
	$logfile          = (defined('PASSCAT_LOGFILE'))       ? PASSCAT_LOGFILE       : '';
	$hash             = (defined('PASSCAT_HASH'))          ? PASSCAT_HASH          : '';
	$extern_form_auth = (defined('PASSCAT_EXT_FORM_AUTH')) ? PASSCAT_EXT_FORM_AUTH : '';

	$extern_file_auth = DC_SHARE_DIR.'/passCat/passCat_auth';

	if(file_exists($extern_file_auth))
		$extern_file_auth_content = file_get_contents($extern_file_auth);
	else
		$extern_file_auth_content = '';

	buffer::str('<h3>'.__('passCat Configuration').'</h3>');

	buffer::str('<form action="'.$url.'" method="post">');

	buffer::str('<h4>'.__('Debug Logs').'</h4>');
	# checkbox : passcat_debug
	buffer::str('<p>'.form::checkbox('passcat_debug','true',$debug,'','passcat_debug').
	            '<label>'.__('Activate passCat DEBUG').' '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_debug').
	            '</label>'.'</p>');
	buffer::str('<div id="p_passcat_logfile">');
	buffer::str(' <ul>');
	buffer::str('  <li>'.
	            '   <p>'.
	            '    <label for="passcat_logfile">'.
	            '     <strong>'.__('LOG File').'&nbsp;: </strong> '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_logfile').
	            '    </label>'.
	# field : passcat_logfile
	            form::field('passcat_logfile',40,255,$logfile,'','class="max"').
	            '   </p>'.
	            '  </li>');
	# checkbox : passcat_debug_turn
	buffer::str('  <li>'.
	            '   <p>'.form::checkbox('passcat_debug_turn','true',$debug_turn,'','passcat_debug_turn').
	            '   <label>'.__('Turn passCat DEBUG?').' '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_debug_turn').
	            '   </label>'.
	            '   </p>');
	buffer::str('   <div id="p_passcat_debug_turn">');
	buffer::str('    <p>'.
	            '     <label for="passcat_debug_max">'.
	            '      <strong>'.__('Max size (kB) of LOG File (1024 kB = 1 MB)').'&nbsp;: </strong> '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_debug_max').
	            '     </label>'.
	# field : passcat_debug_max
	            form::field('passcat_debug_max',40,255,$debug_max,'','class="max"').
	            '    </p>');
	buffer::str('    <p>'.
	            '     <label for="passcat_debug_nb">'.
	            '      <strong>'.__('Number of LOG Files').'&nbsp;: </strong> '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_debug_nb').
	            '     </label>'.
	# field : passcat_debug_nb
	            form::field('passcat_debug_nb',40,255,$debug_nb,'','class="max"').
	            '    </p>'.
	            '   </div>'.
	            '  </li>');
	buffer::str(' </ul>');
	buffer::str('</div>');

	buffer::str('<h4>'.__('Password Hash').'</h4>');
		# checkbox : passcat_hash
	buffer::str('<p>'.form::checkbox('passcat_hash','true',$hash,'','passcat_hash').
	            '<label>'.__('Hash passwords ?').' '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_hash').
	            '</label>'.'</p>');
	buffer::str('<div id="p_passcat_hash">'.
	            '<ul>'.
	            '<li>'.
	            '<p>'.
	            __('If you activate "Password Hash" option, you increase the safety of your protected '.
	            'categories but that induces that only hashes of yours passwords will be to record '.
	            'in the table passCat: Passwords will be not readable!').
	            '</p>'.
	            '<p>'.
	            __('If your passCat table is already used and contains only clear passwords, it should '.
	            'be converted: this operation is definitive!').
	            '</p>'.
	            '<p style="text-align:center; color:red;"><b>'.__('Don\'t convert an already converted passCat table !!!').'</b></p>'.
	            '<p>'.
	            __('To convert your passCat table').' : <a href="tools/passcat/hashPasswords.php?hash=1" onclick="popup(this.href); '.
	            'return false;">'.__('click here').'</a>'.
	            '</p>'.
	            '</li>'.
	            '<li>'.
	            '<p>'.
	            __('If you deactivate "Password Hash" option, you drop the safety of your protected '.
	            'categories: Passwords will be readable in your passCat table!').
	            '</p>'.
	            '<p>'.
	            __('If your passCat table is already used and contains hashed passwords, you should '.
	            'enter your passwords again!').
	            '</p>'.
	            '<p>'.
	            __('To enter easily all your passCat passwords').' : <a href="tools/passcat/hashPasswords.php?clear=1" onclick="popup(this.href); '.
	            'return false;">'.__('click here').'</a>'.
	            '</p>'.
	            '</li>'.
	            '</ul>'.
	            '</div>');

	buffer::str('<h4>'.__('External Form Authentication').'</h4>');
	# checkbox : passcat_ext_form_auth
	buffer::str('<p>'.form::checkbox('passcat_ext_form_auth','true',$extern_form_auth,'','passcat_ext_form_auth').
	            '<label>'.__('Activate external form authentication').' '.
	            helpLink('passcat_config&amp;plugin=passcat','passcat_ext_form_auth').
	            '</label>'.'</p>');
	buffer::str('<p id="p_passcat_ext_file_auth"><label><strong>'.__('External Form Auth').'&nbsp;: </strong></label>'.
	# textArea : passcat_ext_auth_content
	            form::textArea('passcat_ext_file_auth_content',80,15,$extern_file_auth_content,'','').'</p>');

	buffer::str('<p><input class="submit" type="submit" name="submit" value="'.
	            __('save').'" /></p>');
	buffer::str('<p>'.form::hidden('updLogFile','true').'</p>');
	buffer::str('<p>'.dcNonce::form().'</p>');
	buffer::str('</form>');
}

# Enregistrement de la configuration de passCat
function passCat_config() {
	global $passCat_config;

	$passcat_debug   = (!empty($_POST['passcat_debug']))      ? $_POST['passcat_debug']      : 'false';
	$passcat_logfile = (!empty($_POST['passcat_logfile']))    ? $_POST['passcat_logfile']    : '';
	$passcat_debug_turn = (!empty($_POST['passcat_debug_turn'])) ? $_POST['passcat_debug_turn'] : 'false';
	$passcat_debug_max  = (!empty($_POST['passcat_debug_max']))  ? $_POST['passcat_debug_max']  : '1024';
	$passcat_debug_nb   = (!empty($_POST['passcat_debug_nb']))   ? $_POST['passcat_debug_nb']   : '7';

	$passcat_hash    = (!empty($_POST['passcat_hash'])) ? $_POST['passcat_hash'] : 'false';

	$passcat_ext_form_auth = (!empty($_POST['passcat_ext_form_auth'])) ? $_POST['passcat_ext_form_auth'] : 'false';
	$passcat_ext_file_auth = DC_SHARE_DIR.'/passCat/passCat_auth';
	$passcat_ext_file_auth_content = (!empty($_POST['passcat_ext_file_auth_content'])) ? $_POST['passcat_ext_file_auth_content'] : '';



	if ($passcat_debug != 'false' && $passcat_logfile == '') {
		buffer::str('<p><strong>'.__('Please, fill LOG File').'</strong></p>');
		passCat_form_config();
	}
	elseif ($passcat_ext_form_auth != 'false' && $passcat_ext_file_auth_content == '') {
		buffer::str('<p><strong>'.__('Please, fill External auth').'</strong></p>');
		passCat_form_config();
	}
	else {
		$passCat_config->editVar('PASSCAT_DEBUG',        $passcat_debug);
		$passCat_config->editVar('PASSCAT_DEBUG_TURN',   $passcat_debug_turn);
		$passCat_config->editVar('PASSCAT_DEBUG_MAX',    $passcat_debug_max);
		$passCat_config->editVar('PASSCAT_DEBUG_NB',     $passcat_debug_nb);
		$passCat_config->editVar('PASSCAT_LOGFILE',      $passcat_logfile);
		$passCat_config->editVar('PASSCAT_HASH',         $passcat_hash);
		$passCat_config->editVar('PASSCAT_EXT_FORM_AUTH',$passcat_ext_form_auth);
		$passCat_config->saveFile();

		if($passcat_ext_form_auth) {
			if(!file_exists($passcat_ext_file_auth)) touch($passcat_ext_file_auth);
			$f = fopen($passcat_ext_file_auth, "w");
			fwrite($f,$passcat_ext_file_auth_content);
			fclose($f);
		}

		passCat_list_cat();
	}
}

# Affichage de la liste des catgories de DotClear
function passCat_list_cat(){
	global $url, $con, $blog;

	buffer::str('<h3>'. __('Categories').'</h3>');

	if ( ($rsCat = $blog->getCat()) == false ) {
		buffer::str(__('Impossible to get categories list'));
	}
	else {
		while($rsCat->fetch()) {
			$cat_id = $rsCat->field('cat_id');
			$cat_libelle = $rsCat->field('cat_libelle');

			$class = 'listcat';
			if($blog->checkPassCat($cat_id)) {
				$class .= ' listcatimg';
			}

			buffer::str(' <strong>');
			buffer::str('   <a class="'.$class.'" href="'.$url.
			            '&amp;cat_id='.$cat_id.'">'.$cat_libelle.'</a>');
			buffer::str(' </strong>');
		}
	}
}

passCat_info('<== passcat/inc/functions_admin.php');

?>
