<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


# configuration de passCat
require_once dirname(__FILE__).'/../../../inc/classes/class.ini.file.php';

$error = '';

# petite correction de la mthode files::makeDir de faon  ce que cette dernire
# renvoie true si tout est OK. Par dfaut elle ne renvoie rien si tout est OK et
# FALSE s'il y a un pb lors du mkdir...
function makeDir($f){
		if (@mkdir($f,fileperms(dirname($f))) === false) {
			return false;
		}
		
		return @chmod($f,fileperms(dirname($f)));
}


$passCat_config_file = DC_SHARE_DIR.'/passCat/passcat.conf';

$os = (DIRECTORY_SEPARATOR == '\\') ? 'win' : 'nix';

# Transformation du chemin, forme std
if ($os == 'win') $passCat_config_file = str_replace('/','\\',$passCat_config_file);

# cration du rpertoire
if (!file_exists(dirname($passCat_config_file))) {
	if ( !makeDir(dirname($passCat_config_file)) ) {
		$error = sprintf(__('Impossible to create %s directory.'), dirname($passCat_config_file));
	}
}

# cration du fichier de conf de base
if ($error == '' && !file_exists($passCat_config_file)) {
	if ( !touch($passCat_config_file) ) {
		$error = sprintf(__('Impossible to create %s configuration file.'), $passCat_config_file);
	}
	else {
		$fp = fopen($passCat_config_file, 'w');
		if ( !fwrite($fp, 'PASSCAT_DEBUG = false'."\n".
		                  'PASSCAT_DEBUG_TURN = false'."\n".
		                  'PASSCAT_DEBUG_MAX = 1024'."\n".
		                  'PASSCAT_DEBUG_NB = 7'."\n".
		                  'PASSCAT_LOGFILE = passCat.log'."\n".
		                  'PASSCAT_HASH = true'."\n".
		                  'PASSCAT_EXT_FORM_AUTH = false') ){
			$error = __('Impossible to write in configuration file.');
		}
	}
}

if ($error == '') {
	$passCat_config = new iniFile($passCat_config_file);
	$passCat_config->read($passCat_config_file);
	
	if ( !defined('PASSCAT_DEBUG') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_DEBUG');
	}
	elseif ( !defined('PASSCAT_DEBUG_TURN') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_DEBUG_TURN');
	}
	elseif ( !defined('PASSCAT_DEBUG_MAX') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_DEBUG_MAX');
	}
	elseif ( !defined('PASSCAT_DEBUG_NB') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_DEBUG_NB');
	}
	elseif ( !defined('PASSCAT_LOGFILE') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_LOGFILE');
	}
	elseif ( !defined('PASSCAT_HASH') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_HASH');
	}
	elseif ( !defined('PASSCAT_EXT_FORM_AUTH') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'PASSCAT_EXT_FORM_AUTH');
	}
}

echo $error;

# gestion des erreurs
require_once dirname(__FILE__).'/inc/classes/class.passcat_error.php';
$passCat_error = new passCat_error();

passCat_info();
passCat_info('[[== PASSCAT : interface d\'administration ==]] ');
passCat_info('==> index.php');

require_once dirname(__FILE__).'/inc/classes/class.passcat.php';
require_once dirname(__FILE__).'/inc/classes/class.passcat_blog.php';


$passCat = new passCat();
$passCat_blog = new passCat_blog($blog,$passCat);
# on "remplace" l'objet xblog par l'objet passCat_blog
$blog = $passCat_blog;


# les fonctions pour l'interface admin
require_once dirname(__FILE__).'/inc/function_admin.php';

# style supplmentaire pour l'interface passCat
$PLUGIN_HEAD =  '  <style type="text/css"> @import "tools/passcat/main.css"; </style>'."\n";

$url = 'tools.php?p=passcat';

# si c'est pour crer la table, cette var = 1
$createtb = (!empty($_POST['createtb'])) ? $_POST['createtb'] : '';

# pour la cration ou la mise  jour du mot de passe
$updPasswd = (!empty($_POST['updPasswd'])) ? $_POST['updPasswd'] : '';

# pour l'obtention des infos sur la table passcat
$info = (!empty($_GET['info'])) ? $_GET['info'] : '';

# si la table passcat doit tre nettoye
$clean = (!empty($_GET['clean'])) ? $_GET['clean'] : '';

# pour l'affichage de la page de configuration de passCat
$config = (!empty($_GET['config'])) ? $_GET['config'] : '';

# pour l'enregistrement de la configuration
$updLogFile = (!empty($_POST['updLogFile'])) ? $_POST['updLogFile'] : '';

$cat_id = (!empty($_POST['cat_id'])) ? $_POST['cat_id'] : '';
if ($cat_id == '') {
	$cat_id = (!empty($_GET['cat_id'])) ? $_GET['cat_id'] : '';
}

passCat_info('  + $createtb   = '.$createtb);
passCat_info('  + $updPasswd  = '.$updPasswd);
passCat_info('  + $info       = '.$info);
passCat_info('  + $config     = '.$config);
passCat_info('  + $updLogFile = '.$updLogFile);
passCat_info('  + $cat_id     = '.$cat_id);

$version = $plugins_list['passcat']['version'];


# titre de la page d'administration du plugin passCat
buffer::str('<h2>passCat '.$version.'</h2>');


# le menu de passCat
buffer::str('<div id="passCat_menu">'.
		'<a href="'.$url.'" '.(($info==''&& $config=='') ? 'id="selected"':'').' >'.__('Categories').'</a>'.
		'<a href="'.$url.'&amp;info=1" '.(($info!='') ? 'id="selected"':'').' >'.__('passCat Table').'</a>'.
		'<a href="'.$url.'&amp;config=1" '.(($config!='') ? 'id="selected"':'').' >'.__('Configuration').'</a>'.
		'</div>');
buffer::str('<br />');

# test existence table passCat
$sql = 'SHOW TABLES LIKE \''.DB_PREFIX.'passcat\'';
if ( ($rs = $con->select($sql)) != false ) {

	# si la table n'existe pas, cad $rs vide
	if ( $rs->isEmpty() && $createtb != '1') {
		passCat_info('  index.php : La table passcat n\'existe pas');
		passCat_form_tb_creation();
	}

	# sinon si table n'existe pas et qu'on dsire crer la table
	elseif ($rs->isEmpty() && $createtb == '1') {
		passCat_info('  index.php : La table passcat n\'existe pas : cration');
		passCat_tb_creation();
	}

	# sinon on affiche les infos d'une catgorie
	elseif ($info == 1) {
		passCat_info('  index.php : Demande d\'infos sur la table passcat');
		if ($clean == 1) {
			passCat_info('  index.php : Demande de nettoyage de la table');
			passCat_clean_table();
		}
		passCat_passCat_info();
	}

	# sinon on affiche le formulaire de configuration
	elseif ($config == 1) {
		passCat_info('  index.php : Affichage du formulaire de configuration');
		passCat_form_config();
	}

	# sinon on enregistre la configuration
	elseif ($updLogFile != '') {
		passCat_info('  index.php : Mise  jour de la configuration');
		passCat_config();
	}

	# sinon si on cr ou met  jour le mot de passe de la catgorie
	elseif ($cat_id != '' && $updPasswd != '') {
		passCat_info('  index.php : Mis  jour du mot de passe');
		passCat_passwd();
	}

	# sinon on affiche le formulaire du mot de passe de la categorie
	elseif ($cat_id != '') {
		passCat_info('  index.php : Affichage du formulaire pour le mot de passe');
		passCat_form_passwd();
	}

	# sinon liste les catgories
	else {
		passCat_info('  index.php : Affichage de la liste des catgories');
		passCat_list_cat();
	}
						
}
else {
	trigger_error('  ERREUR MySQL : '.$con->error(), E_USER_ERROR);
	buffer::str('ERROR : execute('.$sql.') = false');
	buffer::str('MySQL : '.$con->error());
}

passCat_info('<== index.php');
passCat_info('[[== PASSCAT : interface d\'administration ==]] ');

?>
