<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


passCat_info('==> postcon.php');
passCat_info('    Mode = '.$mode);


$passcat_blog = new passcat_blog($blog, $passCat);
# on "remplace" l'objet xblog par notre objet passCat_blog
$blog = $passcat_blog;


# si auth existe, c'est que le formulaire d'authentification a t valid...
# il faut donc authentifi :D
# On ne peut pas mettre ce bloc dans functions.php car $passCat->authentification()
# fait appel  des fonctions de $blog version passCat, or ce dernier n'est pas
# encore effectif dans functions.php :)
if (!empty($_POST['auth'])) {
	passCat_info('  $_POST[\'auth\'] existe');
	passCat_info('     `-> donc passCat::authentication');

	# si l'authentification est ok
	if ($passCat->authentication()) {

		$type_url = (dc_url_scan == 'query_string') ? '?' : ''; 
		
		passCat_info('  passCat::authentication() = true');

		# s'il s'agit d'un post
		if (!empty($_POST['post_url'])) {
			$redirection = $_POST['post_url'];
		}
		# sinon il s'agit d'une catgorie
		else {
			$redirection = $_POST['cat_libelle_url'];
		}

		passCat_info('     `-> donc on redirige vers '.dc_blog_url.$type_url.$redirection);

		# faut qu'on mette  jour le cache au sujet de la page index
		define('DC_UPDATE_FILE',dirname(__FILE__).'/../../../index.php');
		$blog->triggerMassUpd();

		# redirige vers l'index de la catgorie
		# (on est oblig de redirig pour que le cookie cr lors de authentication()
		# soit envoy)
		header('Location: '.dc_blog_url.$type_url.$redirection);
	}
	
	#sinon on laisse couler :D
	passCat_info('  ...On laisse couler...');
	passCat_info('    + passCat::auth    = '.$passCat->getAuth());
	passCat_info('    + passCat::error   = '.$passCat->error);
	passCat_info('    + passCat::warning = '.$passCat->warning);
}


// pour le plugin Pagination, on intercepte le mode "pagination"
if ($mode == "pagination") {

	global $dc_orig_mode, $page_nav;

	passCat_info('mode = pagination, avec dc_orig_mode = '.$dc_orig_mode);

	switch ($dc_orig_mode) {
		case 'cat'  :
		case 'home' : {
			$page_nav = new pagenavigator($blog->countLastNews($cat_id), $pagination_url);
			$news = $blog->getLastNews($page_nav->getLimitString(),$cat_id,'post_dt DESC');
			break;
		}
		case 'year' : {
			$page_nav = new pagenavigator($blog->countPostByDate($year,'','',$cat_id), $pagination_url);
			// Le mode 'year' semble dsactiv dans DC 1.2, mais on ne sait jamais...
			$news = $blog->getPostByDate($year,'','',$cat_id,'post_dt DESC','','',$page_nav->getLimitString());
			break;
		}
		case 'month' : {
			$page_nav = new pagenavigator($blog->countPostByDate($year,$month,'',$cat_id), $pagination_url);
			$news = $blog->getPostByDate($year,$month,'',$cat_id,'post_dt DESC','','',$page_nav->getLimitString());
			break;
		}
		case 'day'   : {
			$page_nav = new pagenavigator($blog->countPostByDate($year,$month,$day,$cat_id), $pagination_url);
			$news = $blog->getPostByDate($year,$month,$day,$cat_id,'post_dt DESC','','',$page_nav->getLimitString());
			break;
		}
		default: break;
	}
}


passCat_info('<== postcon.php');
passCat_info('[[== PASSCAT : le blog ==]] ');

?>
