<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of passCat plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# passCat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# passCat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with passCat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

# variable pour revenir  la racine du dotclear
$base = '/../../..';

require dirname(__FILE__).$base.'/inc/prepend.php';

# configuration de passCat
require_once dirname(__FILE__).$base.'/inc/classes/class.ini.file.php';
require_once dirname(__FILE__).$base.'/inc/libs/lib.files.php';


$passCat_config_file = DC_SHARE_DIR.'/passCat/passcat.conf';
if (!file_exists(dirname($passCat_config_file))) files::makeDir(dirname($passCat_config_file));
if (!file_exists($passCat_config_file)) touch($passCat_config_file);

$passCat_config = new iniFile($passCat_config_file);
$passCat_config->read($passCat_config_file);

# gestion des erreurs
require_once dirname(__FILE__).'/inc/classes/class.passcat_error.php';
$passCat_error = new passCat_error();


require dirname(__FILE__).$base.'/layout/lib.cache.php';

require dirname(__FILE__).$base.'/layout/class.xblog.php';
require dirname(__FILE__).$base.'/layout/class.xblogpost.php';
require dirname(__FILE__).$base.'/layout/class.xblogcomment.php';

require dirname(__FILE__).'/inc/classes/class.passcat.php';
require dirname(__FILE__).'/inc/classes/class.passcat_blog.php';


$type = (!empty($_GET['type']) && $_GET['type'] == 'co') ? 'co' : 'blog';
$cat = (!empty($_GET['cat'])) ? $_GET['cat'] : '';
$lang = (!empty($_GET['lang'])) ? $_GET['lang'] : '';

# Connexion MySQL
$con = new Connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);

if ($con->error()) { exit; }

# Cration de l'objet de type weblog avec uniquement les billets
# publis
$blog = new xblog($con,DB_PREFIX,1,dc_encoding);
$blog->rs_blogpost = 'xblogpost';
$blog->rs_blogcomment = 'xblogcomment';

$blog->setURL('post','http://'.$_SERVER['HTTP_HOST'].dc_blog_url.dc_format_post_url);

$passCat = new passCat();

$passcat_blog = new passcat_blog($blog,$passCat);

$blog = $passcat_blog;

# test pour savoir si la cat est protge
if ($cat != '') {

	$passCat->setHTTPAuth(true);

	$authorised = $blog->OKPassCat($cat);

	# dans le cas o l'authentification a t remplie
	if ( (isset($_SERVER['PHP_AUTH_PW']) && !empty($_SERVER['PHP_AUTH_PW']))) {

		# on rcupre le mot de passe tap
		$PHP_AUTH_PW = strip_tags($_SERVER['PHP_AUTH_PW']);

		if (PASSCAT_HASH) {
			$PHP_AUTH_PW = md5($PHP_AUTH_PW);
		}

		# on rcupre le passe passCat de cette catgorie
		$passCat_password = $blog->getPassCat($cat);

		$authorised = ($PHP_AUTH_PW == $passCat_password);

		$passCat->setHTTPAuthOK($authorised);
	}

	# si pas autoris
	if( !$authorised ) {
		# on va envoyer les en-ttes d'authentification
 		$message = "passCat authentication";
		header('WWW-Authenticate: Basic realm="' . $my_message . '"');
		header('HTTP/1.0 401 Unauthorized');

		# en cas d'annulation
		echo 'Tss j\'ai demander de taper quelque chose !!!!!';
		exit;
	}
	# sinon pas de pb, on laisse couler :D
}


# Si type = co on fait un fil des commentaires
if ($type == 'co')
{
	if (!empty($_GET['post'])) {
		$comments = $blog->getComments($_GET['post'],'DESC');
	} else {
		$comments = $blog->getComments('','DESC',20);
	}
	
	$title = dc_blog_name.' - Commentaires';
	$ts = time();
	$items = $seq = '';
	
	if (!$comments->isEmpty())
	{
		$ts = $comments->getTS();
		
		while(!$comments->EOF())
		{
			$seq .= $comments->getRSSSeq();
			$items .= $comments->getRSSItem(dc_short_feeds);
			
			$comments->moveNext();
		}
	}
}
else
{
	# Dernires nouvelles
	$news = $blog->getLastNews(10,$cat,'post_dt DESC',false,$lang);
	
	$ts = strtotime($blog->getEarlierDate());
	$title = dc_blog_name;
	
	$items = $seq = '';
	while(!$news->EOF())
	{
		$items .= $news->getRSSItem(dc_short_feeds);
		$seq .= $news->getRSSSeq();
		
		$news->moveNext();
	}
}

# Fermeture de connexion
$con->close();

# Cache HTTP
if (dc_http_cache && defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W)
{
	$mod_files = get_included_files();
	$mod_files[] = DC_UPDATE_FILE;
	$mod_files[] = dirname(__FILE__).$base.'/conf/dotclear.ini';
	
	cache::http($mod_files);
}

header('Content-Type: text/xml; charset='.dc_encoding);
echo '<?xml version="1.0" encoding="'.dc_encoding.'" ?>'."\n";
?>
<rdf:RDF
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:admin="http://webns.net/mvcb/"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
  xmlns="http://purl.org/rss/1.0/">

<channel rdf:about="<?php echo 'http://'.$_SERVER['HTTP_HOST'].dc_blog_url; ?>">
  <title><?php echo $blog->toXML($title); ?></title>
  <description><![CDATA[<?php echo dc_blog_desc; ?>]]></description>
  <link><?php echo 'http://'.$_SERVER['HTTP_HOST'].dc_blog_url; ?></link>
  <dc:language><?php echo DC_LANG; ?></dc:language>
  <dc:creator></dc:creator>
  <dc:rights></dc:rights>
  <dc:date><?php echo dt::iso8601($ts); ?></dc:date>
  <admin:generatorAgent rdf:resource="http://www.dotclear.net/" />
  
  <sy:updatePeriod>daily</sy:updatePeriod>
  <sy:updateFrequency>1</sy:updateFrequency>
  <sy:updateBase><?php echo dt::iso8601($ts); ?></sy:updateBase>
  
  <items>
  <rdf:Seq>
  <?php echo $seq; ?>
  </rdf:Seq>
  </items>
</channel>

<?php echo $items; ?>

</rdf:RDF>
